<?php
/**
* @version      1.1.1 06.10.2011
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/
namespace Joomla\Component\Jshopping\Administrator\Controller;
use Joomla\Component\Jshopping\Site\Lib\ImageLib;

defined( '_JEXEC' ) or die( 'Restricted access' );

class ResizeController extends BaseadminController{

     function init(){
        \JSFactory::loadExtLanguageFile('resize');
        \JSHelperAdmin::addSubmenu("other");
    }

    function display($cachable = false, $urlparams = false){ 
        $db = \JFactory::getDBO();
        $view=$this->getView("resize", 'html');      
        $view->display();
    }
   
    function resize(){
		set_time_limit(0);
        $mainframe = \JFactory::getApplication(); 
        $jshopConfig = \JSFactory::getConfig();
        $jinput = \JFactory::getApplication()->input;
        \JPluginHelper::importPlugin('jshoppingadmin');
        $dispatcher = \JFactory::getApplication();
		$start = $jinput->getInt('start');
		$limit = 50;
		$next = $start + $limit;
        
        $filelist =  glob($jshopConfig->image_product_path .'/'.'full_*');
		
        foreach($filelist as $key=>$value){
			if ($key < $start) {
				continue;
			}
			if ($key > $next) {				
				sleep(0.1);		
				print "Loaded: ".$next." / ".count($filelist)."<br>";
				print "<script>location.href='index.php?option=com_jshopping&controller=resize&task=resize&start=".$next."';</script>";
				die();
			}
            $url = $value;
            $url_parts = pathinfo($url);
            //filenames
            $name_full = $url_parts['basename'];
            $name_image = substr($url_parts['basename'],5);
            $name_thumb = "thumb_".$name_image;
            //file path
            $path_image = $jshopConfig->image_product_path .'/'.$name_image;
            $path_thumb = $jshopConfig->image_product_path .'/'.$name_thumb;
            $path_full = $jshopConfig->image_product_path .'/'.$name_full;
            //resize thumb
            $product_width_image = $jshopConfig->image_product_width;
            $product_height_image = $jshopConfig->image_product_height;            
            if (!ImageLib::resizeImageMagic($path_full, $product_width_image, $product_height_image, $jshopConfig->image_cut,$jshopConfig->image_fill, $path_thumb, $jshopConfig->image_quality, $jshopConfig->image_fill_color)) {
                \JSError::raiseWarning("",\JText::_('JSHOP_ERROR_CREATE_THUMBAIL')." ".$name_thumb);
                saveToLog("error.log", "Resize Product Image - Error create thumbail ".$name_thumb);
                $error = 1;
            }
            //resize image
            $product_full_width_image = $jshopConfig->image_product_full_width; 
            $product_full_height_image = $jshopConfig->image_product_full_height;            
            if (!ImageLib::resizeImageMagic($path_full, $product_full_width_image, $product_full_height_image, $jshopConfig->image_cut,$jshopConfig->image_fill, $path_image, $jshopConfig->image_quality, $jshopConfig->image_fill_color)) {
                \JSError::raiseWarning("",\JText::_('JSHOP_ERROR_CREATE_THUMBAIL')." ".$name_image);
                saveToLog("error.log", "Resize Product Image - Error create image ".$name_image);
                $error = 1;
            } 
            $dispatcher->triggerEvent('onAfterSaveProductImage', array($product_id, $name_image));    
        }
        
        if (!$jinput->get("noredirect")){
            \JSError::raiseMessage( 404, \JText::_('JSHOP_COMPLETED'));
            $mainframe->redirect("index.php?option=com_jshopping&controller=resize&task=view");
        }
    }
}
